SystemOrganization addCategory: #'Ma Armored Code-API'!
SystemOrganization addCategory: #'Ma Armored Code-Exceptions'!
SystemOrganization addCategory: #'Ma Armored Code-Info'!
SystemOrganization addCategory: #'Ma Armored Code-Network testing'!
SystemOrganization addCategory: #'Ma Armored Code-SUnit extensions'!
SystemOrganization addCategory: #'Ma Armored Code-private'!

!TestResult methodsFor: '*ma armored code' stamp: 'cmm 4/18/2002 00:54'!
maDebugCase: aTestCase

	aTestCase runCase.
	self passed add: aTestCase
! !

!TestResult methodsFor: '*ma armored code' stamp: 'cmm 4/18/2002 00:56'!
maDebugCaseAsFailure: aTestCase

	aTestCase halt runCase.
	self passed add: aTestCase
! !

MaObject subclass: #MaNetworkTestPlayer
	instanceVariableNames: 'testCase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma Armored Code-Network testing'!

!MaNetworkTestPlayer class methodsFor: 'as yet unclassified' stamp: 'cmm 7/2/2002 00:13'!
testCaseClass: aNetworkTestCaseClass

	^self new 
		setTestCaseClass: aNetworkTestCaseClass;
		yourself! !

!MaNetworkTestPlayer methodsFor: 'actions' stamp: 'cmm 6/7/2004 23:53'!
loadCodeFrom: aPositionableStream

	aPositionableStream position: 0.
	aPositionableStream 
		maFileInAnnouncing: 'loading code from conductor..' 
		logged: false! !

!MaNetworkTestPlayer methodsFor: 'request framework requirements' stamp: 'cmm 6/22/2004 10:37'!
processRequest: aMaNetworkTestPlayerRequest

	| result |
	self maMarked: 'magic'.  "This method called as part of test-script user-setup.  See MagmaTesterPackageInfo>>#readmeText."
	MaArmoredCodeNotification signal: 'Processing ', aMaNetworkTestPlayerRequest printString.
	result _ aMaNetworkTestPlayerRequest processFor: self.
	^ result == testCase ifFalse: [ result ]! !

!MaNetworkTestPlayer methodsFor: 'actions' stamp: 'cmm 10/30/2004 17:27'!
protocol

	^ testCase playerProtocol! !

!MaNetworkTestPlayer methodsFor: 'actions' stamp: 'cmm 6/7/2004 21:55'!
remotePerform: selector withArguments: anArray

	| result |
	result _ testCase
		perform: selector
		withArguments: anArray.
	^ (result == testCase or: [ result == self ])
		ifTrue: [ nil ]
		ifFalse: [ result ]! !

!MaNetworkTestPlayer methodsFor: 'actions' stamp: 'cmm 6/6/2004 13:24'!
setTestCaseClass: aClass

	testCase _ aClass new! !

MaObject subclass: #MaNetworkTestPlayerFacade
	instanceVariableNames: 'link name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma Armored Code-private'!

!MaNetworkTestPlayerFacade class methodsFor: 'creation' stamp: 'cmm 7/5/2008 14:30'!
host: aString port: anInteger 
	^ self 
		name: nil
		host: aString
		port: anInteger! !

!MaNetworkTestPlayerFacade class methodsFor: 'creation' stamp: 'cmm 7/5/2008 14:28'!
name: aString host: hostName port: anInteger 
	^ self new
		name: aString ;
		link: 
			(MaTcpRequestServerLink location: (MaServerLocation 
					host: hostName
					port: anInteger)) ;
		yourself! !

!MaNetworkTestPlayerFacade methodsFor: 'initializing' stamp: 'cmm 5/2/2002 23:58'!
connect

	link connect
! !

!MaNetworkTestPlayerFacade methodsFor: 'initializing' stamp: 'cmm 4/27/2002 14:50'!
link: aMaServerLink

	link _ aMaServerLink! !

!MaNetworkTestPlayerFacade methodsFor: 'player access' stamp: 'cmm 5/22/2002 10:21'!
name

	^name
! !

!MaNetworkTestPlayerFacade methodsFor: 'initializing' stamp: 'cmm 5/8/2002 22:00'!
name: aString

	name _ aString! !

!MaNetworkTestPlayerFacade methodsFor: 'private' stamp: 'cmm 5/22/2002 17:32'!
pushClass: aClass

	| stream |
	stream _ ReadWriteStream on: String new.
	aClass
		fileOutOn: stream
		moveSource: false
		toFile: 0.
	^self pushCode: stream
! !

!MaNetworkTestPlayerFacade methodsFor: 'private' stamp: 'cmm 3/21/2003 00:55'!
pushCode: aPositionableStream

	MaArmoredCodeNotification signal: 'pushing code to ', name.
	^self submit:
		(MaPushCodeRequest new
			stream: aPositionableStream;
			yourself)! !

!MaNetworkTestPlayerFacade methodsFor: 'player access' stamp: 'cmm 3/21/2003 00:55'!
remotePerform: selectorSymbol withArguments: anArray

	MaArmoredCodeNotification signal: 'remote performing ', selectorSymbol, ' with arguments ', anArray printString, ' in ', name.
	^self submit:
		(MaRemotePerformRequest new
			selector: selectorSymbol;
			arguments: anArray)! !

!MaNetworkTestPlayerFacade methodsFor: 'player access' stamp: 'cmm 3/21/2003 00:55'!
setTestCaseClass: aClass
	"Make sure you have first updated the ChangeSet that contains your test case class, or the player may not be able to instantiate it."

	MaArmoredCodeNotification signal: 'setting test case class to ', aClass name, ' in ', name.
	^self submit:
		(MaSetTestCaseClassRequest new
			testCaseClass: aClass;
			yourself)
! !

!MaNetworkTestPlayerFacade methodsFor: 'private' stamp: 'cmm 1/2/2003 14:46'!
submit: aMaNetworkTestPlayerRequest

	| result |
	result _ link submit: aMaNetworkTestPlayerRequest.
	result maIsException 
		ifTrue: [ result class signal: result messageText ]
		ifFalse: [ ^result ]! !

!MaNetworkTestPlayerFacade methodsFor: 'initializing' stamp: 'cmm 10/16/2002 17:04'!
timeoutSeconds: anInteger

	link timeoutSeconds: anInteger! !

MaClientServerRequest subclass: #MaNetworkTestPlayerRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma Armored Code-private'!

!MaNetworkTestPlayerRequest methodsFor: 'as yet unclassified' stamp: 'cmm 12/23/2002 17:42'!
processFor: aMaNetworkTestPlayer

	self subclassResponsibility! !

MaNetworkTestPlayerRequest subclass: #MaPushCodeRequest
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma Armored Code-private'!

!MaPushCodeRequest methodsFor: 'private' stamp: 'cmm 6/7/2004 23:53'!
processFor: aMaNetworkTestPlayer

	aMaNetworkTestPlayer loadCodeFrom: self stream.
	^ nil! !

!MaPushCodeRequest methodsFor: 'accessing' stamp: 'cmm 4/27/2002 15:16'!
stream

	^stream
! !

!MaPushCodeRequest methodsFor: 'accessing' stamp: 'cmm 4/27/2002 15:16'!
stream: aPositionableStream

	stream _ aPositionableStream! !

MaNetworkTestPlayerRequest subclass: #MaRemotePerformRequest
	instanceVariableNames: 'selector arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma Armored Code-private'!

!MaRemotePerformRequest methodsFor: 'accessing' stamp: 'cmm 5/6/2002 23:28'!
arguments

	^arguments
! !

!MaRemotePerformRequest methodsFor: 'accessing' stamp: 'cmm 5/6/2002 23:28'!
arguments: aSymbol

	arguments _ aSymbol
! !

!MaRemotePerformRequest methodsFor: 'private' stamp: 'cmm 4/27/2002 16:33'!
processFor: aMaNetworkTestPlayer

	^aMaNetworkTestPlayer
		remotePerform: self selector
		withArguments: self arguments
! !

!MaRemotePerformRequest methodsFor: 'accessing' stamp: 'cmm 4/27/2002 15:07'!
selector

	^selector
! !

!MaRemotePerformRequest methodsFor: 'accessing' stamp: 'cmm 4/27/2002 15:07'!
selector: aSymbol

	selector _ aSymbol
! !

MaNetworkTestPlayerRequest subclass: #MaSetTestCaseClassRequest
	instanceVariableNames: 'testCaseClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma Armored Code-private'!

!MaSetTestCaseClassRequest methodsFor: 'private' stamp: 'cmm 6/7/2004 23:59'!
processFor: aMaNetworkTestPlayer

	aMaNetworkTestPlayer setTestCaseClass: self testCaseClass.
	^ nil! !

!MaSetTestCaseClassRequest methodsFor: 'accessing' stamp: 'cmm 5/27/2002 20:15'!
testCaseClass

	^testCaseClass! !

!MaSetTestCaseClassRequest methodsFor: 'accessing' stamp: 'cmm 5/27/2002 20:15'!
testCaseClass: aClass

	testCaseClass _ aClass! !

PackageInfo subclass: #MaArmoredCodePackageInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma Armored Code-Info'!

!MaArmoredCodePackageInfo methodsFor: 'as yet unclassified' stamp: 'cmm 2/2/2003 12:13'!
prerequisitePackages

	^#('Ma client server')! !

!TestSuite methodsFor: '*ma armored code' stamp: 'cmm 4/18/2002 00:39'!
maDebug

	self maRunUsing: #maDebug:
! !

!TestSuite methodsFor: '*ma armored code' stamp: 'cmm 4/18/2002 00:41'!
maDebug: aResult 

	self
		maExecuteTestsUsing: #maDebug:
		result: aResult
! !

!TestSuite methodsFor: '*ma armored code' stamp: 'cmm 4/18/2002 00:43'!
maDebugAsFailure

	self maRunUsing: #maDebugAsFailure:
! !

!TestSuite methodsFor: '*ma armored code' stamp: 'cmm 4/18/2002 00:42'!
maDebugAsFailure: aResult 

	self
		maExecuteTestsUsing: #maDebugAsFailure:
		result: aResult
! !

!TestSuite methodsFor: '*ma armored code' stamp: 'cmm 9/6/2007 21:07'!
maExecuteTestsUsing: aSymbol result: aResult

	self maMarked: 'dev'.
"I couldn't figure out how 'resources' was meant to be used with regard to TestSuites.  I definitely need to maintain testing resources for Magma, but SUnit's implementation with regard to resources seems incomplete.  That's why the only way to properly test Magma is 'MagmaTestCase suite maDebug'."
	self tests isEmpty ifTrue: [ ^self ].
	[ self tests anyOne class setUpSuite.
	self tests do: 
		[:each | 
		self changed: each.
		each
			perform: aSymbol
			with: aResult ] ] ensure: [ self tests anyOne class tearDownSuite ]
! !

!TestSuite methodsFor: '*ma armored code' stamp: 'cmm 9/16/2006 18:57'!
maRunUsing: aSymbol
	| result |
	result := TestResult new.
	[ self 
		perform: aSymbol 
		with: result ] 
			ensure: [self resources do: [:each | each reset ] ].
	^ result! !

MaSingleton subclass: #MaArmoredCodeOptions
	instanceVariableNames: 'testEnvironmentDirectory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma Armored Code-API'!

!MaArmoredCodeOptions class methodsFor: 'initializing' stamp: 'cmm 10/6/2004 16:40'!
initialize

	self reset! !

MaNotification subclass: #MaArmoredCodeNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma Armored Code-Exceptions'!

TestCase subclass: #MaTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma Armored Code-SUnit extensions'!

!MaTestCase commentStamp: '<historical>' prior: 0!
Getting ready to try using "fixtureSpecs" so we can test against hundreds of fixtures easily.
!

MaTestCase subclass: #MaNetworkTestCase
	instanceVariableNames: ''
	classVariableNames: 'NextPort Players'
	poolDictionaries: ''
	category: 'Ma Armored Code-Network testing'!

!MaNetworkTestCase commentStamp: '<historical>' prior: 0!
My subclasses are intended to test network programs.  I provide methods for communicating with other images and tunnelling requests to them.!

!MaNetworkTestCase class methodsFor: 'initializing' stamp: 'cmm 7/5/2008 14:25'!
addPlayerNamed: aString 
	self 
		addPlayerNamed: aString
		at: (self getHostNameFor: aString)
		port: self getNextPort! !

!MaNetworkTestCase class methodsFor: 'initializing' stamp: 'cmm 7/5/2008 14:28'!
addPlayerNamed: aString at: hostName port: anInteger 
	"The player must first be running and listening on port anInteger."
	self players 
		at: aString
		put: (MaNetworkTestPlayerFacade 
			name: aString
			host: hostName
			port: anInteger) connect.
	MaClientServerPreferences debug: true.
	(self playerNamed: aString) timeoutSeconds: 172800	"2 days"! !

!MaNetworkTestCase class methodsFor: 'other squeak images' stamp: 'cmm 8/26/2005 14:55'!
client1ImageFilename
	"All subclasses must override with a unique-name, otherwise the startUp: methods of each will start the test-player server."

	self subclassResponsibility ! !

!MaNetworkTestCase class methodsFor: 'other squeak images' stamp: 'cmm 8/26/2005 14:56'!
client2ImageFilename
	"All subclasses must override with a unique-name, otherwise the startUp: methods of each will start the test-player server."

	self subclassResponsibility ! !

!MaNetworkTestCase class methodsFor: 'other squeak images' stamp: 'cmm 8/24/2005 17:18'!
conductorImageFilename

	^ '_testConductor.image'! !

!MaNetworkTestCase class methodsFor: 'other squeak images' stamp: 'cmm 8/24/2005 17:18'!
createAndLaunchImageNamed: aString

	self
		createImageNamed: aString ;
		launchImageNamed: aString! !

!MaNetworkTestCase class methodsFor: 'other squeak images' stamp: 'cmm 8/24/2005 17:05'!
createAndLaunchPlayerImages

	self isConductorImage
		ifTrue:
			[ { self client1ImageFilename. self client2ImageFilename. self serverImageFilename }
				do:
					[ : each |
					self createAndLaunchImageNamed: each ] ]! !

!MaNetworkTestCase class methodsFor: 'other squeak images' stamp: 'cmm 8/24/2005 17:18'!
createImageNamed: aString

	| imageName changesName |

	imageName := aString, '.image'.
	MaNotification signal: 'deleting ', imageName.
	FileDirectory default deleteFileNamed: imageName.
	MaNotification signal: 'copying ', SmalltalkImage current imageName, ' to ', imageName.
	FileDirectory default
		copyFileNamed: SmalltalkImage current imageName
		toFileNamed: imageName.

	changesName := aString, '.changes'.
	MaNotification signal: 'deleting ', changesName.
	FileDirectory default deleteFileNamed: changesName.
	MaNotification signal: 'copying ', SmalltalkImage current changesName, ' to ', changesName.
	FileDirectory default
		copyFileNamed: SmalltalkImage current changesName
		toFileNamed: changesName! !

!MaNetworkTestCase class methodsFor: 'accessing' stamp: 'cmm 8/24/2005 17:20'!
defaultServerPort

	^ 51969! !

!MaNetworkTestCase class methodsFor: 'other squeak images' stamp: 'cmm 9/12/2007 22:05'!
executableName
	"Florian said SmalltalkImage current getSystemAttribute: 0 does not work for him on his Linux, 
		http://lists.squeakfoundation.org/pipermail/magma/2007-September/000831.html
	so we have this check for Unix."
	^ ((Smalltalk hasClassNamed: #OSProcess) and: [ OSProcess isUnix ]) 
		ifTrue: [ (Smalltalk classNamed: #OSProcess) programName ]
		ifFalse: [ SmalltalkImage current getSystemAttribute: 0 ]! !

!MaNetworkTestCase class methodsFor: 'accessing' stamp: 'cmm 7/5/2008 14:26'!
getHostNameFor: playerName 
	^ 'localhost'

	"Commenting out this old code to allow for one-click run of network test cases."
	"
	^(self players includesKey: playerName)
		ifTrue:
			[ (self playerNamed: playerName) hostname ]
		ifFalse:
			[ NetNameResolver addressFromString: 
				(FillInTheBlank 
					request: 'Enter the hostname of ', playerName
					initialAnswer: 'localhost') ]"! !

!MaNetworkTestCase class methodsFor: 'accessing' stamp: 'cmm 5/27/2002 15:16'!
getNextPort

	^NextPort _ NextPort + 1
! !

!MaNetworkTestCase class methodsFor: 'initializing' stamp: 'cmm 5/27/2002 15:27'!
initializeNextPort

	NextPort _ 1313
! !

!MaNetworkTestCase class methodsFor: 'other squeak images' stamp: 'cmm 8/24/2005 17:06'!
isConductorImage

	^ (FileDirectory default localNameFor: SmalltalkImage current imageName) = self conductorImageFilename! !

!MaNetworkTestCase class methodsFor: 'public' stamp: 'cmm 8/24/2005 17:22'!
kickoff

	self
		validate ;
		warn ;
		kickoffWithoutWarning! !

!MaNetworkTestCase class methodsFor: 'public' stamp: 'cmm 6/5/2008 22:39'!
kickoffWithoutWarning
	MaClientServerPreferences debug: true.
	"	World findATranscript: nil."	"Causes problems in 3.8, not sure why.  Opening below only in conductor image."
	ScreenController new fullScreenOff.
	"Easier window management in the OS by sizing the windows down.."
	Display class 
		depth: Display depth
		width: Display width * 3 // 4
		height: Display height * 3 // 4
		fullscreen: false.
	World doOneCycleNow.
	self
		saveImageAs: self conductorImageFilename ;
		createAndLaunchPlayerImages.
	self isConductorImage ifTrue: 
		[ World findATranscript: nil.	"temp code (hopefully), see above."
		self waitForPlayerImages ]! !

!MaNetworkTestCase class methodsFor: 'other squeak images' stamp: 'cmm 9/12/2007 22:01'!
launchImageNamed: aString
	| imageName |
	imageName := FileDirectory default fullNameFor: aString, '.image'.
	MaNotification signal: 'launching ', imageName.
	(Smalltalk hasClassNamed: #OSProcess)
		ifTrue:
			[ (Smalltalk classNamed: #OSProcess) command: self executableName, ' ', imageName ]
		ifFalse:
			[ Warning signal: 'Cannot launch ', imageName, ' because OSProcess package is not loaded.  Please launch this image yourself before Proceeding.' ]! !

!MaNetworkTestCase class methodsFor: 'private' stamp: 'cmm 7/15/2006 10:07'!
maDebugSuite
	"Kickoff each subclass, #maDebug.."
	self withAllSubclassesDo: [ : each | each suite maDebug ]! !

!MaNetworkTestCase class methodsFor: 'accessing' stamp: 'cmm 5/27/2002 19:34'!
playerNamed: aString

	^self players at: aString
! !

!MaNetworkTestCase class methodsFor: 'accessing' stamp: 'cmm 6/22/2007 13:37'!
players
	^ Players! !

!MaNetworkTestCase class methodsFor: 'accessing' stamp: 'cmm 6/22/2007 13:40'!
players: aDictionary
	"Key is the player name, value is a MaNetworkTestPlayerFacade."
	Players _ aDictionary! !

!MaNetworkTestCase class methodsFor: 'accessing' stamp: 'cmm 5/27/2002 19:35'!
playersDo: aBlock

	self players do: aBlock! !

!MaNetworkTestCase class methodsFor: 'other squeak images' stamp: 'cmm 8/24/2005 20:59'!
readyAt: portInteger

	| socket |
	^ [ socket := 
		Socket newTCP
			connectTo: #(127 0 0 1) asByteArray 
			port: portInteger
			waitForConnectionFor: 5.
		socket closeAndDestroy.
		true ]

		on: ConnectionTimedOut
		do:
			[ : err | 
			MaArmoredCodeNotification signal: 'Waiting for port ', portInteger printString, ' to listen.'.
			false ]! !

!MaNetworkTestCase class methodsFor: 'initializing' stamp: 'cmm 6/22/2007 13:38'!
removePlayerNamed: aString 
	self players removeKey: aString! !

!MaNetworkTestCase class methodsFor: 'other squeak images' stamp: 'cmm 8/24/2005 17:18'!
saveImageAs: fileNameString

	SmalltalkImage current 
		closeSourceFiles ;
		saveChangesInFileNamed: (SmalltalkImage current fullNameForChangesNamed: fileNameString) ;
		saveImageInFileNamed: (SmalltalkImage current fullNameForImageNamed: fileNameString)! !

!MaNetworkTestCase class methodsFor: 'other squeak images' stamp: 'cmm 8/26/2005 14:56'!
serverImageFilename
	"All subclasses must override with a unique-name, otherwise the startUp: methods of each will start the test-player server."

	self subclassResponsibility ! !

!MaNetworkTestCase class methodsFor: 'framework' stamp: 'cmm 6/22/2007 13:38'!
setUpSuite
	super setUpSuite.
	self
		players: Dictionary new ;
		initializeNextPort! !

!MaNetworkTestCase class methodsFor: 'private' stamp: 'cmm 8/24/2005 17:19'!
validate

	(Smalltalk hasClassNamed: #OSProcess) ifFalse: [ Warning signal: 'OSProcess is recommended to run the test cases with one-click.  Otherwise you will be prompted to launch several images at various times.' ]! !

!MaNetworkTestCase class methodsFor: 'other squeak images' stamp: 'cmm 8/24/2005 17:27'!
waitForPlayerImages

	| client1Ready client2Ready serverReady |
	client1Ready := client2Ready := serverReady := false.
	[ client1Ready & client2Ready & serverReady ]
		whileFalse:
			[ client1Ready := client1Ready or: [ client1Ready := self readyAt: 1314 ].
			client2Ready := client2Ready or: [ client2Ready := self readyAt: 1315 ].
			serverReady := serverReady or: [ serverReady := self readyAt: 1316 ].
			(Delay forSeconds: 1) wait ]! !

!MaNetworkTestCase class methodsFor: 'private' stamp: 'cmm 12/18/2006 12:32'!
warn

	Warning signal:
		'You are about to kick off network test cases.  To simulate a client-server environment, the suite runs in separate images.  Each of the images is created automatically by saving four copies of this image and its changes file.  One to host the server, one for each client, and one known as the "conductor" image, sends instructions to the others in order to execute the test.

This image is about to be saved under a different name ("', self conductorImageFilename, '") and launch a test-suite.  It is therefore recommended to save this image (under its current name) to capture your work before proceeding.

The following uncommon TCP/IP ports are opened in order to run the test.
		
	1314 - the client one testPlayer (in ', self client1ImageFilename, '.image)
	1315 - the client two testPlayer (in ', self client2ImageFilename, '.image)
	1316 - the server testPlayer (in ', self serverImageFilename, '.image)
	51969 - the server (in ', self serverImageFilename, '.image)
'! !

!MaNetworkTestCase methodsFor: 'players' stamp: 'cmm 7/5/2008 14:25'!
getHostNameFor: playerName 
	^ self class getHostNameFor: playerName! !

!MaNetworkTestCase methodsFor: 'players' stamp: 'cmm 5/27/2002 19:32'!
playerNamed: aString

	^self class playerNamed: aString
! !

!MaNetworkTestCase methodsFor: 'accessing' stamp: 'cmm 10/30/2004 17:26'!
playerProtocol

	^ MaNetworkTestPlayerRequest allSubclasses
		add: UndefinedObject ;
		yourself! !

!MaNetworkTestCase methodsFor: 'players' stamp: 'cmm 5/27/2002 19:33'!
playersDo: aBlock

	self class playersDo: aBlock! !

!MaNetworkTestCase methodsFor: 'printing' stamp: 'cmm 5/3/2002 00:12'!
printOn: aStream

	testSelector
		ifNil: [ aStream nextPutAll: 'a', self class name ]
		ifNotNil: [ super printOn: aStream ]
! !

!MaNetworkTestCase methodsFor: 'players' stamp: 'cmm 5/1/2003 17:12'!
pushClass: aClass

	self playersDo: [ :each | each pushClass: aClass ]! !

!MaNetworkTestCase methodsFor: 'players' stamp: 'cmm 5/7/2002 22:56'!
remotePerform: selectorSymbol in: playerName

	^(self playerNamed: playerName)
		remotePerform: selectorSymbol
		withArguments: Array new! !

!MaNetworkTestCase methodsFor: 'players' stamp: 'cmm 5/8/2002 21:54'!
remotePerform: selectorSymbol with: arg1 in: playerName

	^(self playerNamed: playerName)
		remotePerform: selectorSymbol
		withArguments: (Array with: arg1)
! !

!MaNetworkTestCase methodsFor: 'players' stamp: 'cmm 5/8/2002 21:54'!
remotePerform: selectorSymbol withArguments: anArray in: playerName

	^(self playerNamed: playerName)
		remotePerform: selectorSymbol
		withArguments: anArray! !

!MaTestCase class methodsFor: 'framework' stamp: 'cmm 5/27/2002 14:47'!
setUpSuite
	"Subclasses may implement general set-up code for 
	that should only run once for all tests.  For example,
	network tests maintain a connection to other machines
	that participate in the test.  The facades to these other
	machines needs to be maintained."
! !

!MaTestCase class methodsFor: 'testing' stamp: 'cmm 4/18/2002 00:11'!
shouldInheritSelectors

	^false! !

!MaTestCase class methodsFor: 'framework' stamp: 'cmm 4/8/2005 13:05'!
tearDownSuite
	"Counterpart to setUpSuite.  See that method for
	more info."

	Transcript cr; show: 'Tests complete.  Tearing down suite..'! !

!MaTestCase methodsFor: 'file management' stamp: 'cmm 12/5/2002 23:11'!
deleteFilesNamed: aCollection

	aCollection do:
		[ :each |
		StandardFileStream allInstances do:
			[ :eachStream |
			eachStream fullName = each ifTrue:
				[ self notify: 'closing a rogue FileStream for ', eachStream fullName.
				eachStream close ] ].
		self notify: 'deleting file ', each.
		(FileDirectory forFileName: each) deleteFileNamed: each ]! !

!MaTestCase methodsFor: 'accessing' stamp: 'cmm 9/11/2008 19:44'!
environmentDirectory

	^ FileDirectory default! !

!MaTestCase methodsFor: 'accessing' stamp: 'cmm 10/7/2004 16:59'!
environmentPath

	^ self environmentDirectory pathName! !

!MaTestCase methodsFor: 'running' stamp: 'cmm 4/18/2002 00:54'!
maDebug: aTestResult

	aTestResult maDebugCase: self
! !

!MaTestCase methodsFor: 'running' stamp: 'cmm 4/18/2002 00:56'!
maDebugAsFailure: aTestResult

	aTestResult maDebugCaseAsFailure: self
! !

!MaTestCase methodsFor: 'private' stamp: 'cmm 8/19/2007 22:10'!
notify: aString 
	MaArmoredCodeNotification signal: DateAndTime now printString , ':  ' , aString! !

!MaTestCase methodsFor: 'private' stamp: 'cmm 8/19/2007 22:08'!
performTest
	[ self
		notify: 'running ' , self selector , '.. ' ;
		notify: 'time to run ' , self selector , ':  ' , [ super performTest ] durationToRun printString ] 
		on: MaNotification
		do: 
			[ : n | 
			Transcript
				cr ;
				show: n messageText.
			n resume ]! !

!MaTestCase methodsFor: 'accessing' stamp: 'cmm 10/7/2004 17:13'!
projectDirectory
	"The projectDirectory typically resides in the projectsDirectory, with my subclasses typically appending their project name to the projectsDirectory."

	self subclassResponsibility! !

!MaTestCase methodsFor: 'accessing' stamp: 'cmm 10/7/2004 17:27'!
projectsDirectory

	^ (FileDirectory default directoryExists: 'My projects')
		ifTrue:
			[ FileDirectory on: (FileDirectory default fullNameFor: 'My projects') ]
		ifFalse:
			[ FileDirectory default ]! !

!MaTestCase methodsFor: 'accessing' stamp: 'cmm 10/7/2004 17:26'!
resourcesDirectory

	^ (self projectDirectory directoryExists: 'Resources')
		ifTrue:
			[ FileDirectory on: (self projectDirectory fullNameFor: 'Resources') ]
		ifFalse: [ self projectDirectory ]! !
MaArmoredCodeOptions initialize!
